{-# LANGUAGE OverloadedStrings #-}

module Datarekisteri.Backend.Email where

import Datarekisteri.Backend.Types
import Data.Text (Text)
import Data.Text.Lazy (fromStrict)
import Datarekisteri.Core.Types
import Network.Mail.Mime

sendDatarekisteriEmail :: MonadEmail m => Email -> Text -> Text -> m ()
sendDatarekisteriEmail to subject content = do
    from <- fromAddress
    sendEmail $ simpleMail' (Address Nothing $ renderEmail to) from subject $ fromStrict content

sendVerificationEmail :: MonadEmail m => Email -> Text -> m ()
sendVerificationEmail to secret = sendDatarekisteriEmail to "Sähköpostin vahvistuskoodi" $
        "Vahvista sähköpostisi syöttämällä alla oleva koodi rekisteriin:\n\n"
        <> secret <> "\n\n"
        <> "Mikäli et odottanut tätä viestiä, voit jättää sen turvallisesti huomiotta."

sendApplicationAcceptedEmail :: MonadEmail m => Email -> m ()
sendApplicationAcceptedEmail to = sendDatarekisteriEmail to "Jäsenhakemus hyväksytty" $
        "Jäsenhakemuksesi Datat RY:lle on hyväksytty. Olet nyt yhdistyksen jäsen."

sendApplicationRejectedEmail :: MonadEmail m => Email -> m ()
sendApplicationRejectedEmail to = sendDatarekisteriEmail to "Jäsenhakemus hylätty" $
        "Jäsenhakemuksesi Datat RY:lle on hylätty. Voit halutessasi kysyä hakemuksen"
        <> " hylkäämisen syistä yhdistyksen hallitukselta <hallitus@datat.fi>."
